//
//  iso9141_io.h
//  ISO9141-2 and ISO15031-5(SAE J1979) protocol simple driver
//  Copyright(C)2012 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2012.02.27 v0.0  First cording
//

unsigned char iso9141_open(void);
unsigned char iso9141_close(void);
unsigned char iso9141_init(unsigned char keyword[2]);
unsigned char iso9141_send_msg(unsigned char *data, unsigned char len);
unsigned char iso9141_recv_response(unsigned char *data, unsigned char *len);

// Error code
#define ISO9141_ERR_SEND				10
#define ISO9141_ERR_TIMEOUT_SYNC		21
#define ISO9141_ERR_TIMEOUT_KEYWORD		22
#define ISO9141_ERR_TIMEOUT_ADDR		23
#define ISO9141_ERR_TIMEOUT_RESPONSE	24
#define ISO9141_ERR_PROTOCOL_ADDR		31
#define ISO9141_ERR_PROTOCOL_CSUM		32

// Timming
#define W0_MIN		2					// [ms]
#define W1_MIN		60					// [ms]
#define W2_MIN		5					// [ms]
#define W3_MIN		0					// [ms]
#define W4_MIN		25					// [ms]
#define SYNC_TRY	100					// max 300ms (300ms/50ms)

#define P1_MIN		0					// [ms]
#define P2_MIN		25					// [ms]
#define P2_MAX		50					// [ms]
#define P3_MIN		55					// [ms]
#define P4_MIN		5					// [ms]
