//
//  uart.h
//  Software UART
//  Copyright(C)2012 Toyohiko Togashi tog001@nifty.com
//
//
//  This program is free software; you can redistribute it and/or modify it under the terms of the
//  GNU General Public License as published by the Free Software Foundation; either version 3
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
//  without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//  See the GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along with this program.
//  If not, see <http://www.gnu.org/licenses/>
//
//
//    Update history
//    ---------- ----- -------------------------------------------
//    2012.02.27 v0.0  First cording
//

unsigned char uart_open(void);
unsigned char uart_close(void);
unsigned char uart_send(unsigned char *data, unsigned char len);
unsigned char uart_recv(unsigned char *data, unsigned char len);
unsigned char uart_send_slow(unsigned char *data, unsigned char len);

// TX pin
#define TX_ON()			(PORTC &= ~_BV(PORTC1))								// Neg
#define TX_OFF()		(PORTC |=  _BV(PORTC1))								//
#define TX_INIT()		((DDRC  |=  _BV(DDC1)), TX_OFF())					// Output
#define TX_TERM()		((DDRC  &= ~_BV(DDC1)), (PORTC &= ~_BV(PORTC1)))	// Reset default

// RX pin
#define RX()			(PINC & _BV(PINC0))									// 
#define RX_INIT()		((DDRC  &= ~_BV(DDC0)), (PORTC &= ~_BV(PORTC0)))	// Input Internal pull-ups disable
#define RX_TERM()		((DDRC  &= ~_BV(DDC0)), (PORTC &= ~_BV(PORTC0)))	// Reset default


#define BIT_TIME		(1000000/10400)				// [us] 10.5kbps
#define BIT_TIME_SLOW	(1000/5)					// [ms] 5bps
#define TIME_OUT_COUNT	50000						// TIME_OUT = 1us(overhead) * TIME_OUT_COUNT

//#define DELAY_OFFSET	1							// 1-5: loop code overhead [us]
//#define LED_1_ON()		(PORTD |=  _BV(PORTD2))		// Tx/Rx lamp
//#define LED_1_OFF()		(PORTD &= ~_BV(PORTD2))		// Neg
//#define LED_1_INIT()	(DDRD  |=  _BV(DDD2), LED_1_OFF())

#define DELAY_OFFSET	1							// loop code overhead [us]
#define LED_1_ON()		asm volatile ("nop");
#define LED_1_OFF()		asm volatile ("nop");
#define LED_1_INIT()	


